import "choerodon-ui/pro/lib/data-set/style";
import _DataSet from "choerodon-ui/pro/lib/data-set";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { createContext, useContext, useMemo, useEffect } from 'react';
import { inject } from 'mobx-react';
import { injectIntl } from 'react-intl';
import useStore from "./useStore";
import useEditBlockStore from "./useEditBlockStore";
import useDetailStore from "./useDetailStore";
import TreeDataSet from "./TreeDataSet";
var HEIGHT = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
var Store = /*#__PURE__*/createContext();
export function usePipelineManageStore() {
  return useContext(Store);
}
export var StoreProvider = injectIntl(inject('AppState')(function (props) {
  var projectId = props.AppState.currentMenuType.projectId,
      children = props.children;
  var DEFAULT_SIZE = HEIGHT > 900 ? 20 : 12;

  function handleSelect(record, store, editBlockStore, previous) {
    if (record) {
      var data = record.toData();
      store.setSelectedMenu(data);
    }
  }

  var mainStore = useStore({
    DEFAULT_SIZE: DEFAULT_SIZE
  });
  var editBlockStore = useEditBlockStore(mainStore);
  var detailStore = useDetailStore(mainStore);
  var treeDs = useMemo(function () {
    return new _DataSet(TreeDataSet({
      projectId: projectId,
      mainStore: mainStore,
      editBlockStore: editBlockStore,
      handleSelect: handleSelect,
      DEFAULT_SIZE: DEFAULT_SIZE
    }));
  }, [projectId]);
  useEffect(function () {
    // 处理消息铃铛中审核任务的跳转
    var pattern = new URLSearchParams(window.location.hash);
    var newPipelineId = pattern.get('pipelineId');
    var newPipelineIdRecordId = pattern.get('pipelineIdRecordId');

    if (newPipelineId && newPipelineIdRecordId) {
      mainStore.setSelectedMenu({
        key: "".concat(newPipelineId, "-").concat(newPipelineIdRecordId),
        parentId: newPipelineId,
        devopsPipelineRecordRelId: newPipelineIdRecordId
      });
      mainStore.setExpandedKeys([newPipelineId]);
    }

    treeDs.query();
  }, []);

  var value = _objectSpread(_objectSpread({}, props), {}, {
    prefixCls: 'c7ncd-pipelineManage',
    intlPrefix: 'c7ncd.pipelineManage',
    permissions: ['choerodon.code.project.develop.ci-pipeline.ps.default'],
    mainStore: mainStore,
    treeDs: treeDs,
    detailStore: detailStore,
    editBlockStore: editBlockStore,
    projectId: projectId
  });

  return /*#__PURE__*/React.createElement(Store.Provider, {
    value: value
  }, children);
}));